
#ifndef __SCREEN_H__
#define __SCREEN_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
#define SCREEN_BG_CALC_STR				(u8*)"0123456789+-*/%()"
#define SCREEN_BG_BUFFER_LEN			25

#define CURSOR_SPRITE_NO				0
#define CURSOR_TILE_NO					1

//---------------------------------------------------------------------------
typedef struct {
	u8  buf[SCREEN_BG_BUFFER_LEN];
	u16 bufCnt;
} ST_SCREEN_BG;


typedef struct {
	s16 x;
	s16 y;
	s16 cx;
	s16 cy;
	s16 sx;							//ړ
	s16 sy;
	s16 ex;
	s16 ey;
	u16 sprNo;
	u16 tileNo;
} ST_CURSOR;

//---------------------------------------------------------------------------

EWRAM_CODE void ScreenBgInit();
EWRAM_CODE void ScreenBgDrawPanel();
EWRAM_CODE void ScreenBgDrawBuffer();
EWRAM_CODE void ScreenBgDrawAnswer(u8* pStr);

EWRAM_CODE void ScreenBgSetBuffer(u8 chr);
EWRAM_CODE void ScreenBgSetBufferPrev();

EWRAM_CODE u8   ScreenBgGetPanelChr(u8 idx);


//----
EWRAM_CODE void ScreenSprInit();


//----
EWRAM_CODE void ScreenCurInit();
EWRAM_CODE void ScreenCurMove();
EWRAM_CODE void ScreenCurInput();

EWRAM_CODE void ScreenCurMoveIn(s16 x, s16 y);
EWRAM_CODE void ScreenCurMoveOut();
EWRAM_CODE void ScreenCurMove();


#ifdef __cplusplus
}
#endif
#endif
